import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JProgressBar;

/**
 * Classe que conte totes les dades que comparteixen els threads per anar-les actualitzant
 * @author LUIS
 *
 */

public class dades {
	
	public LinkedList<node> n=new LinkedList<node>();
	public LinkedList<resultat> resultats;
	public int num_nodes=0;
	public int num_missatges=0;
	public int mis_rebuts;
	public int mis_circulants=0;
	public int distancia_max=0;
	float distancia_mitjana_anterior = (float) 0.0;
	public float distancia_mitjana=(float) 0.0;
	public String protocol;
	public JLabel jLabel6 = null;
	public JLabel jLabel8 = null;
	public JLabel jLabel10 = null;
	public JProgressBar jProgressBar;
	public JButton jButton3;
	
	/**
	 * Constructor de la classe dades
	 * @param n
	 * @param num_nodes
	 * @param num_missatges
	 * @param mis_rebuts
	 * @param protocol
	 * @param mis_circulants
	 * @param distancia_max
	 * @param distancia_mitjana
	 * @param jLabel6
	 * @param jLabel8
	 * @param jLabel10
	 * @param jProgressBar
	 * @param jButton3
	 */
	public dades(LinkedList<node> n,int num_nodes,int num_missatges,int mis_rebuts,
			String protocol,int mis_circulants,int distancia_max,float distancia_mitjana,JLabel jLabel6,
			JLabel jLabel8,JLabel jLabel10, JProgressBar jProgressBar, JButton jButton3) {
		super();
		this.n=n;
		this.num_nodes=num_nodes;
		this.mis_rebuts=mis_rebuts;
		this.num_missatges=num_missatges;
		this.protocol=protocol;
		this.mis_circulants=mis_circulants;
		this.distancia_max=distancia_max;
		this.distancia_mitjana=distancia_mitjana;
		this.jLabel6=jLabel6;
		this.jLabel8=jLabel8;
		this.jLabel10=jLabel10;
		this.jProgressBar=jProgressBar;
		this.jButton3=jButton3;
		this.resultats=new LinkedList<resultat>();
	}
	
	public dades(){
		
	}
	
	/**
	 * Funcio que retorna un objecte de tipus resultat de la linkelist resltats
	 * @return LinkedList
	 */
	public LinkedList<resultat> getResultats() {
		return resultats;
	}
	/**
	 * Funcio que fica un objecte de tipus resultat a la llista de resultats
	 * @param resultats
	 */
	public synchronized void setResultats(LinkedList<resultat> resultats) {
		this.resultats = resultats;
	}
	
	/**
	 * Funcio que fica un objecte de tipus resultat a la llista de resultats
	 * @param r
	 */
	public synchronized void addResultats(resultat r) {
		this.resultats.add(r);
	}
	
	/**
	 * Funcio que agafa la distancia mitjana anterior necessaria per calcular la actual
	 * @return float
	 */
	public synchronized float getDistancia_mitjana_anterior() {
		return distancia_mitjana_anterior;
	}
	
	/**
	 * Funcio que actualitza la distancia mitjana anterior necessaria per calcular la actual
	 * @param distancia_mitjana_anterior
	 */
	public synchronized void setDistancia_mitjana_anterior(float distancia_mitjana_anterior) {
		this.distancia_mitjana_anterior = distancia_mitjana_anterior;
	}

	/**
	 * agafa o retorna el num de missatges circulant
	 * @return int
	 */
	public synchronized int getMis_circulants() {
		return mis_circulants;
	}
    
	/**
	 * Actualitza el num de missatges circulant
	 * @param mis_circulants
	 */
	public synchronized void setMis_circulants(int mis_circulants) {
		this.mis_circulants = mis_circulants;
	}
	
	/**
	 * agafa o retorna el num de missatges rebuts
	 * @return int
	 */
	public synchronized int getMis_rebuts() {
		return mis_rebuts;
	}

	/**
	 * Actualitza el num de missatges circulant
	 * @param mis_rebuts
	 */
	public synchronized void setMis_rebuts(int mis_rebuts) {
		this.mis_rebuts = mis_rebuts;
		this.notifyAll();
	}
	
	/**
	 * agafa o retorna la distancia maxima
	 * @return int
	 */
	public int getDistancia_max() {
		return distancia_max;
	}

	/**
	 * Actualitza la distancia maxima
	 * @param distancia_max
	 */
	public synchronized void setDistancia_max(int distancia_max) {
		this.distancia_max = distancia_max;
		this.notifyAll();
	}
	
	/**
	 * agafa o retorna la distancia mitjana
	 * @return
	 */
	public  float getDistancia_mitjana() {
		return distancia_mitjana;
	}

	/**
	 * Actualitza la distancia mitjana
	 * @param distancia_mitjana
	 */
	public synchronized void setDistancia_mitjana(float distancia_mitjana) {
		this.distancia_mitjana = distancia_mitjana;
	}
	
	/**
	 * Agafa o retorna el que hi ha una JLabel
	 * @return Jlabel
	 */
	public JLabel getJLabel10() {
		return jLabel10;
	}

	/**
	 * Actualitza una JLabel
	 * 
	 */
	public void setJLabel10(JLabel label10) {
		jLabel10 = label10;
	}
	
	/**
	 *  Agafa o retorna el que hi ha una JLabel
	 * @return Jlabel
	 */
	public JLabel getJLabel6() {
		return jLabel6;
	}

	/**
	 * Actualitza una JLabel
	 * 
	 */
	public void setJLabel6(JLabel label6) {
		jLabel6 = label6;
	}

	/**
	 *  Agafa o retorna el que hi ha una JLabel
	 *
	 * @return Jlabel
	 */
	public JLabel getJLabel8() {
		return jLabel8;
	}

	/**
	 * Actualitza una JLabel
	 * 
	 */
	public void setJLabel8(JLabel label8) {
		jLabel8 = label8;
	}

	/**
	 * Agafa o retorna el que hi ha una JProgresBar
	 * @return JProgressBar
	 */
	public JProgressBar getJProgressBar() {
		return jProgressBar;
	}

	/**
	 * actualitza el que hi ha a una JProgresBar
	 * 
	 */
	public void setJProgressBar(JProgressBar progressBar) {
		jProgressBar = progressBar;
	}

	/**
	 * Funcio que retorna el num de missatges
	 * @return int
	 */
	public int getNum_missatges() {
		return num_missatges;
	}

	/**
	 * Funcio que actualitza el num de missatges
	 * 
	 */
	public void setNum_missatges(int num_missatges) {
		this.num_missatges = num_missatges;
	}

	/**
	 * Funcio que retorna el num de nodes
	 * @return int
	 */
	public int getNum_nodes() {
		return num_nodes;
	}

	/**
	 * Funcio que actualitza el num de nodes
	 * 
	 **/
	public void setNum_nodes(int num_nodes) {
		this.num_nodes = num_nodes;
	}

	/**
	 * Funcio que retorna el protocol triat
	 * @return String
	 */
	public String getProtocol() {
		return protocol;
	}

	/**
	 * Funcio que actualitza el protocol triat
	 *
	 */
	public void setProtocol(String protocol) {
		this.protocol = protocol;
	}
	
	/**
	 * Funcio que borra els resultats de la llista de resultats
	 * @return String
	 */
	public void borrar_resultats(){
		while (!resultats.isEmpty()){
			this.resultats.removeFirst();
		}
	}
}
